#include <stdio.h>
#include <malloc.h>

int bgmtable[][3]={
	//t@Cʒu@kTCY@𓀃TCY
	{0x00032, 0x01240, 0x04ad3},
	{0x01242, 0x04317, 0x0b101},
	{0x04319, 0x13a24, 0x33ea5},
	{0x13a26, 0x1e2b8, 0x2488c},
	{0x1e2ba, 0x2d2a1, 0x36e28},

	{0x2d2a3, 0x39de2, 0x3141d},
	{0x39de4, 0x432cc, 0x1e3cd},
	{0x432ce, 0x4baec, 0x21e11},
	{0x4baee, 0x5b65d, 0x2d0e1},
	{0x5b65f, 0x9429d, 0x55532},

	{0x7742d, 0x526d2, 0x4c1e9},
};

char bgmfile[][12]={
	"kog_01.mid",
	"kog_02.mid",
	"kog_03.mid",
	"kog_04.mid",
	"kog_05.mid",
	"kog_06.mid",
	"kog_07.mid",
	"kog_08.mid",
	"kog_09.mid",
	"kog_10.mid",
	"kog_11.mid",
};
int decode(char *, int, char *, int);
int bit(char **, int *, int);

int main(int argc, char* argv[]){

	int i;
	char *enc, *dec;
	FILE *datf,*bgmf;

	datf=fopen("MUSIC.DAT","rb");
	if(datf==NULL){
		printf("MUSIC.DAT not found.\n");
		return 0;
	}

	enc = (char *)malloc(0x4ADE20 * 2);
	dec = (char *)malloc(0x4ADE20 * 2);
	if(enc == NULL || dec == NULL){
		printf("Can't allocate memory\n");
		return 0;
	}

	for(i=0; i<11; i++){
		printf("Create %s ... \n",bgmfile[i]);

		bgmf = fopen(bgmfile[i],"wb");
		if(bgmf == NULL){
			printf("Can't open file %s\n", bgmfile[i]);
			break;
		}
		fseek(datf,bgmtable[i][0],SEEK_SET);
		fread(enc,1,bgmtable[i][1],datf);

		decode(enc, bgmtable[i][1], dec, bgmtable[i][2]);

		if(fwrite(dec,1,bgmtable[i][2],bgmf) == 0){
			printf("Can't write file %s\n", bgmfile[i]);
			fclose(bgmf);
			break;
		}
		fclose(bgmf);
	}
	free(enc);
	free(dec);
	fclose(datf);
	
	return 0;
}

//ky@
int decode(char *p1, int d1, char *p2, int d2)
{
	char *dic_p = p2 + 0x630041;
	char *e_p   = p2 + d2;
	char buf;

	int adr;
	int cnt = 1;
	int chk = 0x100;
	int i,j;

	while(p2 < e_p){

		if( bit(&p1, &chk, 1) ){

			buf = bit(&p1, &chk, 8);

			*p2++ = buf;
			*(dic_p + cnt) = buf;
			cnt = (cnt + 1) & 0x1fff;
		}
		else {

			adr = bit(&p1, &chk, 13);
			j   = bit(&p1, &chk, 4);

			for(i=0; i<=j+2; i++){
				buf = *(dic_p + adr);
				adr = (adr + 1) & 0x1fff;

				*p2++ = buf;
				*(dic_p + cnt) = buf;
				cnt = (cnt + 1) & 0x1fff;
			}
		}
	}
	return 0;
}

int bit(char **p1, int *chk, int turn)
{
	int i, result=0;

	for(i=0; i<turn; i++){
		result <<=1;

		*chk >>= 1;
		if(*chk == 0x00){
			*chk = 0x80;
			*p1 = *p1 + 1;
		}

		if(**p1 & *chk)
			result |= 0x01;
	}

	return result;
}
